module sector(radius, angles, fn = 24) {
    r = radius / cos(180 / fn);
    step = -360 / fn;

    points = concat([[0, 0]],
        [for(a = [angles[0] : step : angles[1] - 360]) 
            [r * cos(a), r * sin(a)]
        ],
        [[r * cos(angles[1]), r * sin(angles[1])]]
    );

    difference() {
        circle(radius, $fn = fn);
        polygon(points);
    }
}
module switch_holder() {
	  rotate([0,0,90]) translate([-diametre/2-3,0,0]) union() {
		  difference() {
				intersection() {
					 difference() {
						  cylinder(d=diametre+2*2,h=4,$fn=200);
						  cylinder(d=diametre,h=2,$fn=150);
					 }
					 translate([(diametre+2*2)/2-25,-14,0]) cube([25,28,4]);
				}
		  }
		  
		  translate([(diametre+2*2)/2-2,-14,0]) union() {
				difference() {
					 cube([3,28,4+21]);
					 translate([0,4-.05,8]) cube([3,20+.1,13+.1]);
				}
				translate([2,0,2]) rotate([-90,0,0]) linear_extrude(2) sector(15,[180,270]);
				translate([2,26,2]) rotate([-90,0,0]) linear_extrude(2) sector(15,[180,270]);
		  }
	 }
}


/*module gouttiere() {
	 color("PowderBlue") union() {
		  difference() {
				translate([0,0,15/2])cube([diametre-retrait*2,28,15],center=true);
				translate([-(diametre-retrait*2)/2,0,17]) rotate([0,90,0])
				cylinder(d=25.1,h=diametre-retrait*2);
				translate([50,0,0]) union() {// Trou de fixation à la plaque
					 cylinder(d=3,h=5);
					 translate([0,0,3]) cylinder(d=5,h=2);
				}
				translate([-50,0,0]) union() {// Trou de fixation à la plaque
					 cylinder(d=3,h=5);
					 translate([0,0,3]) cylinder(d=5,h=2);
				}
		  }
		  translate([(diametre-retrait*2-3)/2,0,15]) rotate([0,90,0])
		  difference() {
				cylinder(d=25,h=3,center=true);
				cylinder(d=7.1,h=3,center=true);
				translate([8.5,0,0]) cylinder(d=3.2,h=3,center=true);
				rotate([0,0,180]) translate([8.5,0,0]) cylinder(d=3.2,h=3,center=true);
		  }
		  translate([-((diametre-retrait*2-3)/2),0,15]) rotate([0,90,0])
		  difference() {
				cylinder(d=25,h=3,center=true);
				cylinder(d=7.1,h=3.1,center=true);
				translate([8.5,0,0]) cylinder(d=3.2,h=3,center=true);
				rotate([0,0,180]) translate([8.5,0,0]) cylinder(d=3.2,h=3,center=true);
		  }
	 }
}*/

module gouttiere() {
	 color("PowderBlue") union() {
		  difference() {
				translate([0,0,17/2])cube([diametre-retrait*2,28,17],center=true);
				translate([-(diametre-retrait*2)/2,0,17]) rotate([0,90,0])
				cylinder(d=25.1+tol,h=diametre-retrait*2);
				translate([50,0,0]) union() {// Trou de fixation à la plaque
					 cylinder(d=3,h=5);
					 translate([0,0,1.5]) cylinder(d=6.3,h=3.5);
				}
				translate([-50,0,0]) union() {// Trou de fixation à la plaque
					 cylinder(d=3,h=5);
					 translate([0,0,1.5]) cylinder(d=6.3,h=3.5);
				}
		  }
		  
		  translate([(diametre-retrait*2-3)/2,0,17]) rotate([0,90,0])
		  difference() {
				cylinder(d=25.1+tol,h=3,center=true);
				cylinder(d=7.1+tol,h=3,center=true);
				translate([8.5,0,0]) {
					 cylinder(d=3.2,h=3,center=true);
					 translate([0,0,(3-1.5)/2]) cylinder(d=6,h=1.5,center=true);
				}
				rotate([0,0,180]) translate([8.5,0,0]) {
					 cylinder(d=3.2,h=3,center=true);
					 translate([0,0,(3-1.5)/2]) cylinder(d=6,h=1.5,center=true);
				}
		  }
		  translate([-((diametre-retrait*2-3)/2),0,17]) rotate([0,90,0])
		  difference() {
				cylinder(d=25.1+tol,h=3,center=true);
				cylinder(d=7.1+tol,h=3.1,center=true);
				translate([8.5,0,0]) {
					 cylinder(d=3.2,h=3,center=true);
					 translate([0,0,-(3-1.5)/2]) cylinder(d=6,h=1.5,center=true);
				}
				rotate([0,0,180]) translate([8.5,0,0]) {
					 cylinder(d=3.2,h=3,center=true);
					 translate([0,0,-(3-1.5)/2]) cylinder(d=6,h=1.5,center=true);
				}
		  }
	 }
}

module plaque_motorisation() {
	 color("PowderBlue") union() {
		  difference() {
				cylinder(d=diametre,h=epaisseur);
				// dégagement pour les roues
				translate([diametre/2-retrait,-110/2-30,-.5])
				cube([retrait,110,epaisseur+1]);
				translate([-(diametre/2),-110/2-30,-.5])
				cube([retrait,110,epaisseur+1]);
				// trous pour fixer la gouttière
				translate([50,-30,0]) cylinder(d=3,h=5);
				translate([-50,-30,0]) cylinder(d=3,h=5);
				// Trous pour fixer les haubans supportant la plaque supérieure
				translate([diametre/2-30,diametre/2-60,-.1]) cylinder(d=rayon,h=5);
				translate([-(diametre/2-30),diametre/2-60,-.1]) cylinder(d=rayon,h=5);
				translate([diametre/2-50,-(diametre/2-40),-.1]) cylinder(d=rayon,h=5);
				translate([-(diametre/2-50),-(diametre/2-40),-.1]) cylinder(d=rayon,h=5);
		  
	 
     				
     // Trous de support de L298N si pas d'entretoise imprimée sur la plaque
					 translate([-(largeur_L298N/2-offset_L298N),-55,0])cylinder(d=3.3,h=epaisseur);
					 translate([(largeur_L298N/2-offset_L298N),-55,0])cylinder(d=3.3,h=epaisseur);
					 translate([-(largeur_L298N/2-offset_L298N),-(55+longueur_L298N-2*offset_L298N),0])cylinder(d=3.3,h=epaisseur);

					 translate([(largeur_L298N/2-offset_L298N),-(55+longueur_L298N-2*offset_L298N),0])cylinder(d=3.3,h=epaisseur);
                     
                     // Trous pour attacher la roue libre en métal
                     
		  translate([8,60,0]) {
				cylinder(d=2.5,h=epaisseur);
				
		  }
		  translate([-8,60,0]) {
				cylinder(d=2.5,h=epaisseur);
              
          }
          
          //Trous pour le coupleur de pile
          
          translate([(retrait-(diametre/2))/2-39.78/2+2.39+35,10.93,0])cylinder(d=3.65,h=epaisseur);
          
          translate([(retrait-(diametre/2))/2-39.78/2+2.39,10.93+55.2,0])cylinder(d=3.65,h=epaisseur);
          
          translate([(retrait-(diametre/2))/2,10.93,0])cylinder(d=3.3,h=epaisseur);
          
          translate([(retrait-(diametre/2))/2,10.93+55.2,0])cylinder(d=3.3,h=epaisseur);
          
          //Retrait pour impression (x_plaque < 200mm)
          
          translate([-100,diametre/2-5,0])cube([200,10,epaisseur]);

                           
}
}			
}

$fn=50;
// Paramètres de la base de la plateforme
retrait=34;
diametre=65*2+retrait*2+3*2;
epaisseur=4;
//Pour les fixations
rayon=4.1;
//Pour le L298N
tol = 1.5;
largeur_L298N = 43.64;
longueur_L298N = 43.44;
offset_L298N = 3; // offset pour les trous de fixation par rapport aux bords du pcb

module plateforme() {
    plaque_motorisation();
	 translate([0,-30,0]) gouttiere();
    translate([0,diametre/2-6,2]) color("PowderBlue")  switch_holder();
}

plateforme();